package lu.etat.pch.icefaces;

import com.icesoft.faces.renderkit.dom_html_basic.DomBasicRenderer;
import com.icesoft.faces.renderkit.dom_html_basic.HTML;
import com.icesoft.faces.context.DOMContext;
import com.icesoft.faces.context.effects.JavascriptContext;


import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import java.io.IOException;
import java.util.Map;
import java.util.Set;
import java.util.Collection;
import java.util.Iterator;

import org.w3c.dom.Element;

/**
 * Created by IntelliJ IDEA.
 * User: goebel
 * Date: May 16, 2008
 * Time: 11:21:47 AM
 * To change this template use File | Settings | File Templates.
 */
public class SpinnerRenderer extends DomBasicRenderer {

    public boolean getRendersChildren() {
        return false;
    }

    public void decode(FacesContext facesContext, UIComponent uiComponent) {
        Spinner sp = (Spinner) uiComponent;

        validateParameters(facesContext, uiComponent, Spinner.class);
        if (isStatic(uiComponent)) {
            return;
        }
        String clientId = uiComponent.getClientId(facesContext);

        Map requestMap = facesContext.getExternalContext().getRequestParameterMap();

        Collection values = requestMap.values();
        Set keys = requestMap.keySet();

        for (Iterator iterator = values.iterator(); iterator.hasNext();) {
            Object o = iterator.next();
            System.out.println("values = " + o);
        }

        for (Iterator iterator = keys.iterator(); iterator.hasNext();) {
            Object o = iterator.next();
            System.out.println("keys = " + o);
        }

        System.out.println(requestMap.containsKey(""));

        if (requestMap.containsKey(clientId)) {
//            String decodedValue = (String) requestMap.get(clientId);
            System.out.println("displayed = " + requestMap.get(clientId + "_displayed_"));

            String decodedValue = "-1";
            if (requestMap.get(clientId + "_displayed_") != null) {
                decodedValue = (String) requestMap.get(clientId + "_displayed_");
            } else {
                decodedValue = (String) requestMap.get(clientId);
            }


            // setSubmittedValue is a method in the superclass DomBasicInputRenderer
            setSubmittedValue(uiComponent, decodedValue);
            sp.setValue(Integer.parseInt(decodedValue));
        }

    }

    public void encodeBegin(FacesContext facesContext, UIComponent uiComponent) throws IOException {
        Spinner sp = (Spinner) uiComponent;
        System.out.println("sp.getValue() = " + sp.getValue());
        System.out.println(uiComponent.getClientId(facesContext));

        Map requestMap = facesContext.getExternalContext().getRequestParameterMap();
        String sFormId = "";
        if (requestMap.get("form") != null) {
            sFormId = requestMap.get("form").toString();
        }
        System.out.println("sFormId = " + sFormId);

        DOMContext domContext = DOMContext.attachDOMContext(facesContext, uiComponent);

        JavascriptContext.includeLib("./dojo/dojo.js", facesContext);

        Element container = domContext.createRootElement(HTML.DIV_ELEM);

        Element jsScript = domContext.createElement(HTML.SCRIPT_ELEM);

        StringBuffer jsCode = new StringBuffer();

        String jsFunction = new String(
                "\nfunction iceSpinner(valu) {\n" +
//                "        dojo.byId('"+  uiComponent.getClientId(facesContext)+"-hidden"     +"').value=valu;\n" +
                "        var jsForm = document.getElementById('"+sFormId+"');" +
                "        var jsElement = document.getElementById('"+ uiComponent.getClientId(facesContext) +"');" +
                "        iceSubmitPartial(jsForm, jsElement, null);return false;\n" +
                "    }\n" +
                "dojo.require(\"dijit.form.NumberSpinner\");\n" +
                "dojo.require(\"dojo.parser\");" +
                "dojo.addOnLoad(function(){\n" +
                "        dojo.parser.parse();\n" +
                "    });\n"
        );

        jsCode.append(jsFunction);

        jsScript.setTextContent(jsCode.toString());

        container.appendChild(jsScript);


        Element input = domContext.createElement(HTML.INPUT_ELEM);
        input.setAttribute("dojoType", "dijit.form.NumberSpinner");
//        input.setAttribute("constraints", "{min:"+sp.getMin()+",max:"+sp.getMax()+",places:0}");
        input.setAttribute("value", sp.getValue().toString());
        input.setAttribute("name", uiComponent.getClientId(facesContext));
        input.setAttribute("id", uiComponent.getClientId(facesContext));
        input.setAttribute("class", "medium");
        input.setAttribute("intermediateChanges", "true");
//        input.setAttribute("onChange","dojo.byId('"+ uiComponent.getClientId(facesContext)+"-hidden" + "').value=arguments[0]; iceSubmitPartial(form, this, event);");
//        input.setAttribute("onChange","dojo.byId('"+ uiComponent.getClientId(facesContext)+"-hidden" + "').value=arguments[0]");

        input.setAttribute("onChange","iceSpinner(arguments[0])");
//        input.setAttribute("onChange","iceSubmitPartial(form, this, event);return false;");

        container.appendChild(input);

//        Element inputHidden = domContext.createElement(HTML.INPUT_ELEM);
//        inputHidden.setAttribute("type", "hidden");
//        inputHidden.setAttribute("id", uiComponent.getClientId(facesContext)+"-hidden");
//        inputHidden.setAttribute("value", sp.getValue().toString());

//        container.appendChild(inputHidden);

        domContext.stepOver();

    }

}
